import _extends from '../../../../../@babel_runtime@7.24.5/node_modules/@babel/runtime/helpers/esm/extends.js';
import _objectWithoutPropertiesLoose from '../../../../../@babel_runtime@7.24.5/node_modules/@babel/runtime/helpers/esm/objectWithoutPropertiesLoose.js';
import createMixins from './createMixins.js';
import createPalette from './createPalette.js';
import createTypography from './createTypography.js';
import shadows from './shadows.js';
import createTransitions from './createTransitions.js';
import zIndex from './zIndex.js';
import formatMuiErrorMessage from '../../../../../@mui_utils@5.15.14_@types_react@18.0.18_react@18.3.1/node_modules/@mui/utils/formatMuiErrorMessage/formatMuiErrorMessage.js';
import createTheme$1 from '../../../../../@mui_system@5.15.15_@emotion_react@11.11.4_@emotion_styled@11.11.5_@types_react@18.0.18_react@18.3.1/node_modules/@mui/system/esm/createTheme/createTheme.js';
import deepmerge from '../../../../../@mui_utils@5.15.14_@types_react@18.0.18_react@18.3.1/node_modules/@mui/utils/deepmerge/deepmerge.js';
import defaultSxConfig from '../../../../../@mui_system@5.15.15_@emotion_react@11.11.4_@emotion_styled@11.11.5_@types_react@18.0.18_react@18.3.1/node_modules/@mui/system/esm/styleFunctionSx/defaultSxConfig.js';
import styleFunctionSx from '../../../../../@mui_system@5.15.15_@emotion_react@11.11.4_@emotion_styled@11.11.5_@types_react@18.0.18_react@18.3.1/node_modules/@mui/system/esm/styleFunctionSx/styleFunctionSx.js';
import generateUtilityClass from '../../../../../@mui_utils@5.15.14_@types_react@18.0.18_react@18.3.1/node_modules/@mui/utils/generateUtilityClass/generateUtilityClass.js';

const _excluded = ["breakpoints", "mixins", "spacing", "palette", "transitions", "typography", "shape"];
function createTheme(options = {}, ...args) {
  const {
      mixins: mixinsInput = {},
      palette: paletteInput = {},
      transitions: transitionsInput = {},
      typography: typographyInput = {}
    } = options,
    other = _objectWithoutPropertiesLoose(options, _excluded);
  if (options.vars) {
    throw new Error(process.env.NODE_ENV !== "production" ? `MUI: \`vars\` is a private field used for CSS variables support.
Please use another name.` : formatMuiErrorMessage(18));
  }
  const palette = createPalette(paletteInput);
  const systemTheme = createTheme$1(options);
  let muiTheme = deepmerge(systemTheme, {
    mixins: createMixins(systemTheme.breakpoints, mixinsInput),
    palette,
    // Don't use [...shadows] until you've verified its transpiled code is not invoking the iterator protocol.
    shadows: shadows.slice(),
    typography: createTypography(palette, typographyInput),
    transitions: createTransitions(transitionsInput),
    zIndex: _extends({}, zIndex)
  });
  muiTheme = deepmerge(muiTheme, other);
  muiTheme = args.reduce((acc, argument) => deepmerge(acc, argument), muiTheme);
  if (process.env.NODE_ENV !== 'production') {
    // TODO v6: Refactor to use globalStateClassesMapping from @mui/utils once `readOnly` state class is used in Rating component.
    const stateClasses = ['active', 'checked', 'completed', 'disabled', 'error', 'expanded', 'focused', 'focusVisible', 'required', 'selected'];
    const traverse = (node, component) => {
      let key;

      // eslint-disable-next-line guard-for-in, no-restricted-syntax
      for (key in node) {
        const child = node[key];
        if (stateClasses.indexOf(key) !== -1 && Object.keys(child).length > 0) {
          if (process.env.NODE_ENV !== 'production') {
            const stateClass = generateUtilityClass('', key);
            console.error([`MUI: The \`${component}\` component increases ` + `the CSS specificity of the \`${key}\` internal state.`, 'You can not override it like this: ', JSON.stringify(node, null, 2), '', `Instead, you need to use the '&.${stateClass}' syntax:`, JSON.stringify({
              root: {
                [`&.${stateClass}`]: child
              }
            }, null, 2), '', 'https://mui.com/r/state-classes-guide'].join('\n'));
          }
          // Remove the style to prevent global conflicts.
          node[key] = {};
        }
      }
    };
    Object.keys(muiTheme.components).forEach(component => {
      const styleOverrides = muiTheme.components[component].styleOverrides;
      if (styleOverrides && component.indexOf('Mui') === 0) {
        traverse(styleOverrides, component);
      }
    });
  }
  muiTheme.unstable_sxConfig = _extends({}, defaultSxConfig, other == null ? void 0 : other.unstable_sxConfig);
  muiTheme.unstable_sx = function sx(props) {
    return styleFunctionSx({
      sx: props,
      theme: this
    });
  };
  return muiTheme;
}

export { createTheme as default };
