/**
 * Copyright (c) 2023, WSO2 LLC. (https://www.wso2.com).
 *
 * WSO2 LLC. licenses this file to you under the Apache License,
 * Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import { IdentifiableComponentInterface, SBACInterface } from "@thiva/core/models";
import { FunctionComponent } from "react";
import { FeatureConfigInterface } from "@thiva/admin.core.v1";
/**
 * Prop-types for the add API resources wizard authorization component.
 */
interface AddAPIResourceAuthorizationInterface extends SBACInterface<FeatureConfigInterface>, IdentifiableComponentInterface {
    /**
     * Trigger submission
     */
    triggerSubmission: (submitFunctionCb: () => void) => void;
    /**
     * initial basic details
     */
    initalRequiredAuthorizationValue: boolean;
    /**
     * trigger submission
     */
    setRequiredAuthorization: (requiresAuthorization: boolean) => void;
    /**
     * Submit callback
     */
    submitCallback?: (requiresAuthorization: boolean) => void;
}
/**
 * Add API Resource authorization component.
 *
 * @param props - Props injected to the component.
 * @returns Add API Resource authorization component
 */
export declare const AddAPIResourceAuthorization: FunctionComponent<AddAPIResourceAuthorizationInterface>;
export {};
